#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <malloc.h>
#include <time.h>

#define SHM_PERM              0777
#define SHM_KEY               0x2A

/*--- Semaphore key ---*/
#define SEM_KEY               0x2A
#define SEM_NUM               11
#define SEM_PERM              0777

/*--- Mutexe fr die globalen Variablen ---*/
#define SEM_MUTEX             0

/*--- Semaphore fr den Weihnachtsmann ---*/
#define SEM_WAKEUP            1

/*--- Semaphore fr die Rentiere ---*/
#define SEM_WORK              2
#define SEM_WORK_DONE         3
#define SEM_BYE               4
#define SEM_BACK              5

/*--- Semaphore fr die Elfen ---*/
#define SEM_GO_SANTA          6
#define SEM_CAPACITY          7
#define SEM_ADVISE_GIVEN      8
#define SEM_THANKS            9
#define SEM_LEFT              10 

/*--- neun Rentiere mssen da sein ---*/
#define ALL_REINDEERS         9

/*--- drei Elfen mssen da sein ---*/
#define ALL_ELFES             3

#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
/* union semun is defined by including <sys/sem.h> */
#else
/* according to X/OPEN we have to define it ourselves */
union semun {
          int val;
            /* value for SETVAL */
          struct semid_ds *buf;
              /* buffer for IPC_STAT, IPC_SET */
          unsigned short int *array;
               /* array for GETALL, SETALL */
          struct seminfo *__buf;
              /* buffer for IPC_INFO */
};
#endif


// das shared memory braucht zwei Eintrge
// Anzahl der Rentiere
// Anzahl der Elfen
typedef struct
{
    int numberOfReindeers;
    int numberOfElfes;
} shared_t;

